Attribute VB_Name = "SubCls"
Public Const GWL_WNDPROC = -4

Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal Hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal Hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private oldWndProc As Long
Private WH As Long

Public Function MyWndProc(ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

If wMsg = WM_MEASUREITEM Then
  Dim MIS As MEASUREITEMSTRUCT
      'get MEASUREITEMSTRUCT data into MIS
  CopyMemory MIS, ByVal lParam, Len(MIS)
      'itemData contains the number of the menu item
  If MIS.itemData = 0 Then
      'fill data
    MIS.itemHeight = Form1.Picture1.ScaleHeight
    MIS.itemWidth = Form1.Picture1.ScaleWidth - 12
  ElseIf MIS.itemData = 1 Then
    MIS.itemHeight = Form1.Picture2.ScaleHeight
    MIS.itemWidth = Form1.Picture2.ScaleWidth - 12
  ElseIf MIS.itemData = 2 Then
    MIS.itemHeight = Form1.Picture3.ScaleHeight
    MIS.itemWidth = Form1.Picture3.ScaleWidth - 12
  ElseIf MIS.itemData = 3 Then
    MIS.itemHeight = Form1.Picture4.ScaleHeight
    MIS.itemWidth = Form1.Picture4.ScaleWidth - 12
  ElseIf MIS.itemData = 4 Then
    MIS.itemHeight = Form1.Picture5.ScaleHeight
    MIS.itemWidth = Form1.Picture5.ScaleWidth - 12
  ElseIf MIS.itemData = 5 Then
    MIS.itemHeight = Form1.Picture6.ScaleHeight
    MIS.itemWidth = Form1.Picture6.ScaleWidth - 12
  End If
      'copy data back
  CopyMemory ByVal lParam, MIS, Len(MIS)
      'return true (we have processed the message)
  MyWndProc = 1

ElseIf wMsg = WM_DRAWITEM Then
  Dim DIS As DRAWITEMSTRUCT
        'get DRAWITEMSTRUCT data into DIS
  CopyMemory DIS, ByVal lParam, Len(DIS)
        'itemData contains the number of the menu item
  If DIS.itemData = 0 Then
        'if menu is selected
    If (DIS.itemState And ODS_SELECTED) Then
        'copy selected picture
      BitBlt DIS.hdc, DIS.rcItem.Left, DIS.rcItem.Top, Form1.Picture7.ScaleWidth, Form1.Picture7.ScaleHeight, Form1.Picture7.hdc, 0&, 0&, SRCCOPY
        'display message
      DispStatus ("New Highlighted")
    Else
        'if menu is not selected - display normal picture
      BitBlt DIS.hdc, DIS.rcItem.Left, DIS.rcItem.Top, Form1.Picture1.ScaleWidth, Form1.Picture1.ScaleHeight, Form1.Picture1.hdc, 0&, 0&, SRCCOPY
    End If
  ElseIf DIS.itemData = 1 Then
    If (DIS.itemState And ODS_SELECTED) Then
      BitBlt DIS.hdc, DIS.rcItem.Left, DIS.rcItem.Top, Form1.Picture8.ScaleWidth, Form1.Picture8.ScaleHeight, Form1.Picture8.hdc, 0&, 0&, SRCCOPY
      DispStatus ("Open Highlighted")
    Else
      BitBlt DIS.hdc, DIS.rcItem.Left, DIS.rcItem.Top, Form1.Picture2.ScaleWidth, Form1.Picture2.ScaleHeight, Form1.Picture2.hdc, 0&, 0&, SRCCOPY
    End If
  ElseIf DIS.itemData = 2 Then
    If (DIS.itemState And ODS_SELECTED) Then
      BitBlt DIS.hdc, DIS.rcItem.Left, DIS.rcItem.Top, Form1.Picture9.ScaleWidth, Form1.Picture9.ScaleHeight, Form1.Picture9.hdc, 0&, 0&, SRCCOPY
      DispStatus ("Save Highlighted")
    Else
      BitBlt DIS.hdc, DIS.rcItem.Left, DIS.rcItem.Top, Form1.Picture3.ScaleWidth, Form1.Picture3.ScaleHeight, Form1.Picture3.hdc, 0&, 0&, SRCCOPY
    End If
  ElseIf DIS.itemData = 3 Then
    If (DIS.itemState And ODS_SELECTED) Then
      BitBlt DIS.hdc, DIS.rcItem.Left, DIS.rcItem.Top, Form1.Picture10.ScaleWidth, Form1.Picture10.ScaleHeight, Form1.Picture10.hdc, 0&, 0&, SRCCOPY
      DispStatus ("Save As Highlighted")
    Else
      BitBlt DIS.hdc, DIS.rcItem.Left, DIS.rcItem.Top, Form1.Picture4.ScaleWidth, Form1.Picture4.ScaleHeight, Form1.Picture4.hdc, 0&, 0&, SRCCOPY
    End If
  ElseIf DIS.itemData = 4 Then
      'separator does not need to be selected
    BitBlt DIS.hdc, DIS.rcItem.Left, DIS.rcItem.Top, Form1.Picture5.ScaleWidth, Form1.Picture5.ScaleHeight, Form1.Picture5.hdc, 0&, 0&, SRCCOPY
  ElseIf DIS.itemData = 5 Then
    If (DIS.itemState And ODS_SELECTED) Then
      BitBlt DIS.hdc, DIS.rcItem.Left, DIS.rcItem.Top, Form1.Picture11.ScaleWidth, Form1.Picture11.ScaleHeight, Form1.Picture11.hdc, 0&, 0&, SRCCOPY
      DispStatus ("Exit Highlighted")
    Else
      BitBlt DIS.hdc, DIS.rcItem.Left, DIS.rcItem.Top, Form1.Picture6.ScaleWidth, Form1.Picture6.ScaleHeight, Form1.Picture6.hdc, 0&, 0&, SRCCOPY
    End If
  End If
      'return true (we have processed the message)
  MyWndProc = 1
Else
      'any other message sent to Form1 will be processed by the default window procedure
 MyWndProc = CallWindowProc(oldWndProc, Hwnd, wMsg, wParam, lParam)
End If
End Function


Public Sub SubClass(WndHwnd)
WH = WndHwnd
oldWndProc = SetWindowLong(WndHwnd, GWL_WNDPROC, AddressOf MyWndProc)
End Sub

Public Sub UnSubClass()
Ret& = SetWindowLong(WH, GWL_WNDPROC, oldWndProc)
End Sub

